package org.bdware.sc.sequencing;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

public class PBFTMember implements Serializable {

	private static final long serialVersionUID = -3058672609865345062L;
 	public boolean isMaster;

	public boolean isMaster() {
		return isMaster;
	}

	public static PBFTMember parse(byte[] content) {
		try {
			ByteArrayInputStream input = new ByteArrayInputStream(content);
			ObjectInputStream objectInputStream = new ObjectInputStream(input);
			PBFTMember ret = (PBFTMember) objectInputStream.readObject();
			return ret;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public byte[] toByteArray() {
		ObjectOutputStream out;
		try {
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			out = new ObjectOutputStream(bo);
			out.writeObject(this);
			return bo.toByteArray();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
}
