package org.bdware.sc.sequencing;

import org.bdware.sc.bean.ContractRequest;
import org.bdware.sc.conn.Node;
import org.bdware.sc.units.TrustfulExecutorConnection;

public class ViewAlgorithm implements SequencingAlgorithm {

    private Committer committer;
    private TrustfulExecutorConnection connection;

    public ViewAlgorithm(boolean isMaster) {
    }

    public void setCommitter(Committer c) {
        committer = c;
    }

    public void setConnection(TrustfulExecutorConnection c) {
        connection = c;
    }

    @Override
    public void onMessage(Node node, byte[] msg) {
        PBFTMessage pbftMessage = PBFTMessage.parse(msg);
        if (pbftMessage.type == PBFTType.Request) {
            ContractRequest cr = ContractRequest.parse(pbftMessage.content);
            committer.onCommit(cr);
        }
    }
}
