package org.bdware.sc.units;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.concurrent.atomic.AtomicInteger;

public class RespCache {
    private static final Logger LOGGER = LogManager.getLogger(RespCache.class);
    public String val = null;
    public int count; // copies
    public long time;
    public boolean isExecuting = false;
    AtomicInteger waiter = new AtomicInteger(0);
    boolean timeout = true;

    public boolean waitForHalf() {
        try {
            synchronized (waiter) {
                LOGGER.info("waitForHalf, " + waiter.get() + " count:" + count);
                time = System.currentTimeMillis();
                if (waiter.incrementAndGet() * 2 > count) {
                    return timeout;
                } else {
                    waiter.wait(5000L);
                    timeout &= waiter.get() * 2 > count;
                    if (!timeout) waiter.notifyAll();
                    return timeout;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            timeout &= waiter.get() * 2 > count;
            return timeout;
        }
    }

    public void notifyAllWaiter() {
        synchronized (waiter) {
            waiter.notifyAll();
        }
    }

    public void waitForResult() {
        synchronized (waiter) {
            try {
                waiter.wait(5000L);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
